org.mozilla.javascript.ast

## Class CatchClause

- java.lang.Object
- - org.mozilla.javascript.Node
  - - org.mozilla.javascript.ast.AstNode
    - - org.mozilla.javascript.ast.CatchClause

All Implemented Interfaces:
  java.lang.Comparable<AstNode>, java.lang.Iterable<Node>

    public class CatchClause
    extends AstNode

Node representing a catch-clause of a try-statement. Node type is `Token.CATCH`.

    CatchClause :
            catch ( Identifier [if Expression] ) Block

### Nested Class Summary

### Nested classes/interfaces inherited from class org.mozilla.javascript.ast.AstNode

`AstNode.DebugPrintVisitor, AstNode.PositionComparator`

### Nested classes/interfaces inherited from class org.mozilla.javascript.Node

`Node.NodeIterator`

### Field Summary

### Fields inherited from class org.mozilla.javascript.ast.AstNode

`length, parent, position`

### Fields inherited from class org.mozilla.javascript.Node

`ATTRIBUTE_FLAG, BOTH, CASEARRAY_PROP, CATCH_SCOPE_PROP, CONTROL_BLOCK_PROP, DECR_FLAG, DESCENDANTS_FLAG, DESTRUCTURING_ARRAY_LENGTH, DESTRUCTURING_NAMES, DESTRUCTURING_PARAMS, DESTRUCTURING_SHORTHAND, DIRECTCALL_PROP, END_DROPS_OFF, END_RETURNS, END_RETURNS_VALUE, END_UNREACHED, END_YIELDS, EXPRESSION_CLOSURE_PROP, first, FUNCTION_PROP, GENERATOR_END_PROP, INCRDECR_PROP, ISNUMBER_PROP, JSDOC_PROP, LABEL_ID_PROP, last, LAST_PROP, LEFT, lineno, LOCAL_BLOCK_PROP, LOCAL_PROP, MEMBER_TYPE_PROP, NAME_PROP, next, NON_SPECIALCALL, OBJECT_IDS_PROP, PARENTHESIZED_PROP, POST_FLAG, PROPERTY_FLAG, propListHead, REGEXP_PROP, RIGHT, SKIP_INDEXES_PROP, SPECIALCALL_EVAL, SPECIALCALL_PROP, SPECIALCALL_WITH, TARGETBLOCK_PROP, type, VARIABLE_PROP`

### Constructor Summary

Constructors
Constructor and Description
`CatchClause()`
`CatchClause(int pos)`
`CatchClause(int pos, int len)`

### Method Summary

Methods
`Block` `getBody()` Returns catch body
`AstNode` `getCatchCondition()` Returns catch condition node, if present
`int` `getIfPosition()` Returns position of "if" keyword
`int` `getLp()` Returns left paren position
`int` `getRp()` Returns right paren position
`Name` `getVarName()` Returns catch variable node
`void` `setBody(Block body)` Sets catch body, and sets its parent to this node.
`void` `setCatchCondition(AstNode catchCondition)` Sets catch condition node, and sets its parent to this node.
`void` `setIfPosition(int ifPosition)` Sets position of "if" keyword
`void` `setLp(int lp)` Sets left paren position
`void` `setParens(int lp, int rp)` Sets both paren positions
`void` `setRp(int rp)` Sets right paren position
`void` `setVarName(Name varName)` Sets catch variable node, and sets its parent to this node.
`java.lang.String` `toSource(int depth)` Emits source code for this node.
`void` `visit(NodeVisitor v)` Visits this node, the catch var name node, the condition if non-`null`, and the catch body.

### Methods inherited from class org.mozilla.javascript.ast.AstNode

`addChild, assertNotNull, codeBug, compareTo, debugPrint, depth, getAbsolutePosition, getAstRoot, getEnclosingFunction, getEnclosingScope, getLength, getLineno, getParent, getPosition, hasSideEffects, makeIndent, operatorToString, printList, setBounds, setLength, setParent, setPosition, setRelative, shortName, toSource`

### Methods inherited from class org.mozilla.javascript.Node

`addChildAfter, addChildBefore, addChildrenToBack, addChildrenToFront, addChildToBack, addChildToFront, getChildBefore, getDouble, getExistingIntProp, getFirstChild, getIntProp, getJsDoc, getJsDocNode, getLastChild, getLastSibling, getNext, getProp, getScope, getString, getType, hasChildren, hasConsistentReturnUsage, iterator, labelId, labelId, newNumber, newString, newString, newTarget, putIntProp, putProp, removeChild, removeChildren, removeProp, replaceChild, replaceChildAfter, resetTargets, setDouble, setJsDocNode, setLineno, setScope, setString, setType, toString, toStringTree`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### CatchClause

    public CatchClause()

#### CatchClause

    public CatchClause(int pos)

#### CatchClause

    public CatchClause(int pos,
               int len)

### Method Detail

#### getVarName

    public Name getVarName()

Returns catch variable node

Returns:
  catch variable

#### setVarName

    public void setVarName(Name varName)

Sets catch variable node, and sets its parent to this node.

Parameters:
  `varName` - catch variable
Throws:
  `java.lang.IllegalArgumentException` - if varName is `null`

#### getCatchCondition

    public AstNode getCatchCondition()

Returns catch condition node, if present

Returns:
  catch condition node, `null` if not present

#### setCatchCondition

    public void setCatchCondition(AstNode catchCondition)

Sets catch condition node, and sets its parent to this node.

Parameters:
  `catchCondition` - catch condition node. Can be `null`.

#### getBody

    public Block getBody()

Returns catch body

#### setBody

    public void setBody(Block body)

Sets catch body, and sets its parent to this node.

Throws:
  `java.lang.IllegalArgumentException` - if body is `null`

#### getLp

    public int getLp()

Returns left paren position

#### setLp

    public void setLp(int lp)

Sets left paren position

#### getRp

    public int getRp()

Returns right paren position

#### setRp

    public void setRp(int rp)

Sets right paren position

#### setParens

    public void setParens(int lp,
                 int rp)

Sets both paren positions

#### getIfPosition

    public int getIfPosition()

Returns position of "if" keyword

Returns:
  position of "if" keyword, if present, or -1

#### setIfPosition

    public void setIfPosition(int ifPosition)

Sets position of "if" keyword

Parameters:
  `ifPosition` - position of "if" keyword, if present, or -1

#### toSource

    public java.lang.String toSource(int depth)

Description copied from class: `AstNode`
Emits source code for this node. Callee is responsible for calling this function recursively on children, incrementing indent as appropriate.

Note: if the parser was in error-recovery mode, some AST nodes may have `null` children that are expected to be non-`null` when no errors are present. In this situation, the behavior of the `toSource` method is undefined: `toSource` implementations may assume that the AST node is error-free, since it is intended to be invoked only at runtime after a successful parse.

Specified by:
  `toSource` in class `AstNode`
Parameters:
  `depth` - the current recursion depth, typically beginning at 0 when called on the root node.

#### visit

    public void visit(NodeVisitor v)

Visits this node, the catch var name node, the condition if non-`null`, and the catch body.

Specified by:
  `visit` in class `AstNode`
Parameters:
  `v` - the object to call with this node and its children